/* Initialization */
#include "WaterTank_TestSingleWaterTank_model.h"
#include "WaterTank_TestSingleWaterTank_11mix.h"
#include "WaterTank_TestSingleWaterTank_12jac.h"
#if defined(__cplusplus)
extern "C" {
#endif

void WaterTank_TestSingleWaterTank_functionInitialEquations_0(DATA *data, threadData_t *threadData);

/*
equation index: 1
type: SIMPLE_ASSIGN
tank.fs_inflow = if tank.fs_phi < 0.0 then 0.0 else 0.1 * abs(tank.fs_phi)
*/
void WaterTank_TestSingleWaterTank_eqFunction_1(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,1};
  modelica_boolean tmp0;
  tmp0 = Less((data->simulationInfo->realParameter[5] /* tank.fs_phi PARAM */),0.0);
  (data->localData[0]->realVars[5] /* tank.fs_inflow variable */) = (tmp0?0.0:(0.1) * (fabs((data->simulationInfo->realParameter[5] /* tank.fs_phi PARAM */))));
  TRACE_POP
}

/*
equation index: 2
type: SIMPLE_ASSIGN
$PRE.control1.valve = $START.control1.valve
*/
void WaterTank_TestSingleWaterTank_eqFunction_2(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,2};
  (data->simulationInfo->realVarsPre[13] /* control1.valve DISCRETE */) = (data->modelData->realVarsData[13] /* control1.valve DISCRETE */).attribute .start;
  TRACE_POP
}

/*
equation index: 3
type: SIMPLE_ASSIGN
control1.valve = $PRE.control1.valve
*/
void WaterTank_TestSingleWaterTank_eqFunction_3(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,3};
  (data->localData[0]->realVars[13] /* control1.valve DISCRETE */) = (data->simulationInfo->realVarsPre[13] /* control1.valve DISCRETE */);
  TRACE_POP
}

/*
equation index: 4
type: SIMPLE_ASSIGN
tank.volume = $START.tank.volume
*/
void WaterTank_TestSingleWaterTank_eqFunction_4(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,4};
  (data->localData[0]->realVars[1] /* tank.volume STATE(1,tank.tank_p_f) */) = (data->modelData->realVarsData[1] /* tank.volume STATE(1,tank.tank_p_f) */).attribute .start;
  TRACE_POP
}
extern void WaterTank_TestSingleWaterTank_eqFunction_18(DATA *data, threadData_t *threadData);

extern void WaterTank_TestSingleWaterTank_eqFunction_25(DATA *data, threadData_t *threadData);

extern void WaterTank_TestSingleWaterTank_eqFunction_26(DATA *data, threadData_t *threadData);

extern void WaterTank_TestSingleWaterTank_eqFunction_29(DATA *data, threadData_t *threadData);

extern void WaterTank_TestSingleWaterTank_eqFunction_30(DATA *data, threadData_t *threadData);

extern void WaterTank_TestSingleWaterTank_eqFunction_31(DATA *data, threadData_t *threadData);

extern void WaterTank_TestSingleWaterTank_eqFunction_27(DATA *data, threadData_t *threadData);

extern void WaterTank_TestSingleWaterTank_eqFunction_28(DATA *data, threadData_t *threadData);

extern void WaterTank_TestSingleWaterTank_eqFunction_19(DATA *data, threadData_t *threadData);

extern void WaterTank_TestSingleWaterTank_eqFunction_21(DATA *data, threadData_t *threadData);

extern void WaterTank_TestSingleWaterTank_eqFunction_20(DATA *data, threadData_t *threadData);


/*
equation index: 16
type: SIMPLE_ASSIGN
tank.valve_outflow_int = $START.tank.valve_outflow_int
*/
void WaterTank_TestSingleWaterTank_eqFunction_16(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int equationIndexes[2] = {1,16};
  (data->localData[0]->realVars[0] /* tank.valve_outflow_int STATE(1,tank.valve_outflow) */) = (data->modelData->realVarsData[0] /* tank.valve_outflow_int STATE(1,tank.valve_outflow) */).attribute .start;
  TRACE_POP
}
extern void WaterTank_TestSingleWaterTank_eqFunction_22(DATA *data, threadData_t *threadData);

OMC_DISABLE_OPT
void WaterTank_TestSingleWaterTank_functionInitialEquations_0(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  WaterTank_TestSingleWaterTank_eqFunction_1(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_2(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_3(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_4(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_18(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_25(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_26(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_29(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_30(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_31(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_27(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_28(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_19(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_21(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_20(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_16(data, threadData);
  WaterTank_TestSingleWaterTank_eqFunction_22(data, threadData);
  TRACE_POP
}

int WaterTank_TestSingleWaterTank_functionInitialEquations(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH

  data->simulationInfo->discreteCall = 1;
  WaterTank_TestSingleWaterTank_functionInitialEquations_0(data, threadData);
  data->simulationInfo->discreteCall = 0;
  
  TRACE_POP
  return 0;
}

/* No WaterTank_TestSingleWaterTank_functionInitialEquations_lambda0 function */

int WaterTank_TestSingleWaterTank_functionRemovedInitialEquations(DATA *data, threadData_t *threadData)
{
  TRACE_PUSH
  const int *equationIndexes = NULL;
  double res = 0.0;

  
  TRACE_POP
  return 0;
}


#if defined(__cplusplus)
}
#endif

